// DVs.PRG - Copyleft (1997) - Ivan C Cruz.
//
//  ivancruz@centroin.com.br
//  www.forumbr.com
//
//  Voce pode distribuir, utilizar e alterar livremente estas rotinas desde
//  que mantenha este comentario que identifica o autor original.



// intCh = Converte um valor inteiro (de 0 a 9) para o caracter numerico
// correspondente.

STATIC FUNCTION intCh ( int )

RETURN Chr ( int + 48 )


// DvModulo11 - Retorna 1 dv calculado pelo mtodo do modulo 11 padro. 

FUNCTION DvModulo11 ( str )

LOCAL soma, fator, i

soma := 0
fator := 2
FOR i := Len ( str ) TO 1 STEP -1
    soma := soma + ( Asc ( Substr ( str, i, 1 ) ) - 48 ) * fator
    ++ fator
    IF fator = 10
        fator := 2
    END
END
soma := 11 - ( soma % 11 )

RETURN IF ( soma >= 10, '0', intCh ( soma ) )


// dvMod11ParaCPF - Retorna 1 dv calculado pelo metodo do modulo 11
// ligeiramente alterado para o CPF.

STATIC FUNCTION dvMod11ParaCPF ( str )

LOCAL soma, fator, i

soma := 0
fator := 2
FOR i := Len ( str ) TO 1 STEP -1
    soma := soma + ( Asc ( Substr ( str, i, 1 ) ) - 48 ) * fator
    ++ fator
END
soma := 11 - ( soma % 11 )

RETURN IF ( soma >= 10, '0', intCh ( soma ) )


// DvModulo10 - Retorna 1 dv calculado pelo metodo do modulo 10 padrao.

FUNCTION DvModulo10 ( str )

LOCAL soma, fator, i

soma := 0
fator := 2
FOR i := Len ( str ) TO 1 STEP -1
    soma := soma + ( Asc ( Substr ( str, i, 1 ) ) - 48 ) * fator
    -- fator
    IF fator = 0
        fator := 2
    END
END
soma := 10 - Int ( soma / 11 )

RETURN IF ( soma >= 10, '0', intCh ( soma ) )


// DvCPF - Retorna os dois dvs de um CPF, dado o CPF sem os dvs em forma de
// string (9 caracteres numericos). 

FUNCTION DvCPF ( str )

LOCAL dv1

dv1 := dvMod11ParaCPF ( str )

RETURN dv1 + dvMod11ParaCPF ( str + dv1 )


// DvCGC - Retorna os dois dvs de um CGC, dado o CGC sem os dvs em forma de
// string (12 caracteres numericos).

FUNCTION DvCGC ( str )

LOCAL dv1

dv1 := DvModulo11 ( str )

RETURN dv1 + DvModulo11 ( str + dv1 )


// ValidaCGC - Retorna true se o CGC dado e valido. O CGC deve ser um string
// de 14 caracteres numericos.

FUNCTION ValidaCGC ( str )

LOCAL dvs := DvCGC ( Left ( str, 12 ) )

RETURN Right ( str, 2 ) = dvs


// ValidaCPF - Retorna true se o CPF dado e valido. O CPF deve ser um string
// de 11 caracteres numericos.

FUNCTION ValidaCPF ( str )

LOCAL dvs := DvCPF ( Left ( str, 9 ) )

RETURN Right ( str, 2 ) = dvs
